#ifndef PERILOUS_GAMEFUNC_C
#define PERILOUS_GAMEFUNC_C

#include <math.h>
#include <string.h>
#include <allegro.h>
#include "gamesys.h"
#include "gamefunc.h"
#include "music.h"
#include "hiscore.h"

// draws a secksi dialog somewhere. i think the variables are defined in
// gamefunc.h or something. 
void draw_window(void) {
  drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
  set_trans_blender(0, 0, 0, 100);
  rectfill(pp_globals.dblbuf, ctx1, cty1, ctx2, cty2, makecol(0,0,60));
  drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
  rect(pp_globals.dblbuf, ctx1, cty1, ctx2, cty2, makecol(155,155,155));
  rect(pp_globals.dblbuf, ctx1-1, cty1-1, ctx2+1, cty2+1, makecol(255,255,255));
  rect(pp_globals.dblbuf, ctx1-2, cty1-2, ctx2+2, cty2+2, makecol(155,155,155));
  rectfill(pp_globals.dblbuf, ctx1-2, cty1-20, ctx2+2, cty1-2, makecol(75,75,255));
  line(pp_globals.dblbuf, ctx1-2, cty1-20, ctx1-2, cty1-2, makecol(100,100,200));
  line(pp_globals.dblbuf, ctx2+2, cty1-20, ctx2+2, cty1-2, makecol(100,100,200));
  line(pp_globals.dblbuf, ctx1-2, cty1-20, ctx2+2, cty1-20, makecol(155,155,255));
  line(pp_globals.dblbuf, ctx1-2, cty1-2, ctx2+2, cty1-2, makecol(0,0,155));
  textprintf(pp_globals.dblbuf, font, ctx1+3, cty1-15, 0, "%s", wtt);
  textprintf(pp_globals.dblbuf, font, ctx1+2, cty1-16, makecol(255,255,255), "%s", wtt);
}

// draw a secksi button with the midpoint as x and y - if w is negative, then
// the button size will adapt to text length. a and b.. if they match, the
// button is active.
int draw_button(int x, int y, int w, char *text, int a, int b) {
  if (!text) return b;
  if (w<=0) w=text_length(font, text);
  if (pp_globals.mouse) {
    // if mouse is on top of this button, set this button as active
    if (mouse_x>=(x-(w)-8) && mouse_x<=(x+(w)+8)) {
      if (mouse_y>=(y-(text_height(font))-3) && mouse_y<=(y+(text_height(font))+3)) {
        b=a;
      }
    }
  }
  // draw a yellow subm-rectangle around the button if it is selected
  if (a==b) rectfill(pp_globals.dblbuf, x-(w)-12, y-(text_height(font))-7, x+(w)+12, y+(text_height(font))+7, makecol(200,200,100));
  rectfill(pp_globals.dblbuf, x-(w)-8, y-(text_height(font))-3, x+(w)+8, y+(text_height(font))+3, makecol(100,100,100));
  rect(pp_globals.dblbuf, x-(w)-10, y-(text_height(font))-5, x+(w)+10, y+(text_height(font))+5, 0);
  rect(pp_globals.dblbuf, x-(w)-9, y-(text_height(font))-4, x+(w)+9, y+(text_height(font))+4, makecol(200,200,200));
  line(pp_globals.dblbuf, x+(w)+9, y-(text_height(font))-4, x+(w)+9, y+(text_height(font))+4, makecol(55,55,55));
  line(pp_globals.dblbuf, x-(w)-9, y+(text_height(font))+4, x+(w)+9, y+(text_height(font))+4, makecol(55,55,55));
  textprintf_centre(pp_globals.dblbuf, font, x+1, y-(text_height(font)/2)+1, 0, "%s", text);
  textprintf_centre(pp_globals.dblbuf, font, x, y-(text_height(font)/2), makecol(255,255,255), "%s", text);
  // returns the number of active button - b doesn't change unless you klutz
  // around with the mouse
  return b;
}

// draws the horrible mouse icon.. *sigh* all the things you do to fulfill the rules.
void draw_mouser(void) {
  if (pp_globals.mouseicon) draw_sprite(pp_globals.dblbuf, pp_globals.mouseicon, mouse_x, mouse_y);
}

// update the window dimension for the "nice" effect
void update_window(void) {
  ctx1+=(wtx1-ctx1)/10.0;
  ctx2+=(wtx2-ctx2)/10.0;  
  cty1+=(wty1-cty1)/10.0;
  cty2+=(wty2-cty2)/10.0;
  // also updates the mouseclick flag. sorry.
  if ((!(mouse_b & 1)) && mousetemp) {
    mousetemp=0;
    mouseclick=1;
  }
  if (mouse_b & 1) mousetemp=1;
}

// wraps the value b if it goes over the given limits
int pp_wrap(int a, int b, int c) {
  if (b<a) b+=c+1-a;
  if (b>c) b-=c+1-a;
  return b;
}

// caps the value b to the given limits
int pp_cap(int a, int b, int c) {
  if (b<a) return a;
  if (b>c) return c;
  return b;
}

// draws the scoreboard
void pp_scoreboard(void) {
  textprintf(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/6), 5, makecol(200,200,200), "SCORE");
  textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), 5, makecol(200,155,155), "HI");
  textprintf_right(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH)-(pp_SCREEN_WIDTH/6), 5, makecol(200,200,200), "LEVEL");
  textprintf(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/6), 20, makecol(255,255,255), "%08d", pp_gamedata.score);
  // if the current score > top high score, display the current score instead
  if ((unsigned int)pp_hiscore_entries[0].score>(unsigned int)pp_gamedata.score) textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), 20, makecol(255,255,255), "%08d", pp_hiscore_entries[0].score);
  else textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), 20, makecol(255,255,255), "%08d", pp_gamedata.score);
  textprintf_right(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH)-(pp_SCREEN_WIDTH/6), 20, makecol(255,255,255), "%3d", pp_gamedata.level);
  textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), pp_SCREEN_HEIGHT-55, makecol(255,255,255), "TIME");
  if (pp_gamedata.time>0) rectfill(pp_globals.dblbuf, 0, pp_SCREEN_HEIGHT-29, (int)((pp_SCREEN_WIDTH/(float)pp_gamedata.maxtime)*(float)pp_gamedata.time), pp_SCREEN_HEIGHT-11, makecol(255,(int)((255.0/(float)pp_gamedata.maxtime)*(float)pp_gamedata.time),0));
  if (pp_gamedata.jello) {
    // this jello indicator actually looks pretty cool when active. go get em
    // jelloes!
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle)*5.0), 20.0+(sin(pp_globals.fx_angle3)*5.0), 9, 0);
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle3)*5.0), 20.0+(sin(pp_globals.fx_angle)*5.0), 9, 0);
    circlefill(pp_globals.dblbuf, 20.0+(sin(pp_globals.fx_angle3)*5.0), 20.0+(cos(pp_globals.fx_angle)*5.0), 9, 0);
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle)*5.0), 20.0+(sin(pp_globals.fx_angle3)*5.0), 8, makecol(0,255,0));
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle3)*5.0), 20.0+(sin(pp_globals.fx_angle)*5.0), 8, makecol(0,255,0));
    circlefill(pp_globals.dblbuf, 20.0+(sin(pp_globals.fx_angle3)*5.0), 20.0+(cos(pp_globals.fx_angle)*5.0), 8, makecol(0,255,0));
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle)*5.0)-1, 20.0+(sin(pp_globals.fx_angle3)*5.0)-1, 5, makecol(155,255,155));
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle3)*5.0)-1, 20.0+(sin(pp_globals.fx_angle)*5.0)-1, 5, makecol(155,255,155));
    circlefill(pp_globals.dblbuf, 20.0+(sin(pp_globals.fx_angle3)*5.0)-1, 20.0+(cos(pp_globals.fx_angle)*5.0)-1, 5, makecol(155,255,155));
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle)*5.0)-2, 20.0+(sin(pp_globals.fx_angle3)*5.0)-2, 3, makecol(255,255,255));
    circlefill(pp_globals.dblbuf, 20.0+(cos(pp_globals.fx_angle3)*5.0)-2, 20.0+(sin(pp_globals.fx_angle)*5.0)-2, 3, makecol(255,255,255));
    circlefill(pp_globals.dblbuf, 20.0+(sin(pp_globals.fx_angle3)*5.0)-2, 20.0+(cos(pp_globals.fx_angle)*5.0)-2, 3, makecol(255,255,255));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle)*5.0), 20.0+(sin(pp_globals.fx_angle3)*5.0), 9, 0);
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle3)*5.0), 20.0+(sin(pp_globals.fx_angle)*5.0), 9, 0);
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(sin(pp_globals.fx_angle3)*5.0), 20.0+(cos(pp_globals.fx_angle)*5.0), 9, 0);
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle)*5.0), 20.0+(sin(pp_globals.fx_angle3)*5.0), 8, makecol(0,255,0));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle3)*5.0), 20.0+(sin(pp_globals.fx_angle)*5.0), 8, makecol(0,255,0));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(sin(pp_globals.fx_angle3)*5.0), 20.0+(cos(pp_globals.fx_angle)*5.0), 8, makecol(0,255,0));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle)*5.0)-1, 20.0+(sin(pp_globals.fx_angle3)*5.0)-1, 5, makecol(155,255,155));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle3)*5.0)-1, 20.0+(sin(pp_globals.fx_angle)*5.0)-1, 5, makecol(155,255,155));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(sin(pp_globals.fx_angle3)*5.0)-1, 20.0+(cos(pp_globals.fx_angle)*5.0)-1, 5, makecol(155,255,155));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle)*5.0)-2, 20.0+(sin(pp_globals.fx_angle3)*5.0)-2, 3, makecol(255,255,255));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(cos(pp_globals.fx_angle3)*5.0)-2, 20.0+(sin(pp_globals.fx_angle)*5.0)-2, 3, makecol(255,255,255));
    circlefill(pp_globals.dblbuf, pp_SCREEN_WIDTH-20.0+(sin(pp_globals.fx_angle3)*5.0)-2, 20.0+(cos(pp_globals.fx_angle)*5.0)-2, 3, makecol(255,255,255));
  }
}

// add black & white noise of given intensity to the source bitmap
void pp_bwnoise(BITMAP *src, int inten) {
  int x, y;
  if (src) {
    drawing_mode(DRAW_MODE_TRANS,NULL,0,0);    
    for (x=0; x<src->w; x++) { pp_poll_music(); for (y=0; y<src->h; y++) {
      set_trans_blender(100,100,100,rand()%inten); 
      if (!(rand()%2)) putpixel(src, x, y, 0); 
      else putpixel(src, x, y, makecol(255,255,255)); 
    }}
    drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
  }
}

// the texture generator
BITMAP *pp_texgen(int type, int w, int h) {
  BITMAP *t=create_bitmap(w, h); int i, x, y;
  if (!t) return NULL; i=0;
  switch(type) {
    case 0: // grey noise
      x=0;
      clear_to_color(t, makecol(127,127,127));
      pp_bwnoise(t, 100);
      t=pp_bmp_interpolate(t);
      t=pp_bmp_interpolate(t);
      pp_bwnoise(t, 100);
      t=pp_bmp_interpolate(t);
      break;
    case 1: // 'thinking' clock
      clear(t);
      circlefill(t, w/2, h/2, 16, 0);
      circlefill(t, w/2, h/2, 15, makecol(120,120,120));
      circlefill(t, w/2, h/2, 14, makecol(255,255,255));
      circlefill(t, w/2, h/2, 13, makecol(120,120,120));
      circlefill(t, w/2, h/2, 12, makecol(50,90,50));
      line(t, w/2, h/2, (w/2)+(w/4), h/2, makecol(255,255,255));
      line(t, w/2, h/2, w/2, h/2-(h/3), makecol(255,255,255));      
      t=pp_bmp_interpolate(t);
      floodfill(t, 0, 0, makecol(255,0,255));
      floodfill(t, t->w-1, 0, makecol(255,0,255));
      floodfill(t, t->w-1, t->h-1, makecol(255,0,255));
      floodfill(t, 0, t->h-1, makecol(255,0,255));
      break;
    case 2: // wood panel
      clear_to_color(t, makecol(224,178,84));
      drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
      for (y=0; y<h; y+=rand()%10) { pp_poll_music();
        set_trans_blender(100,100,100,rand()%255);
        line(t, 0, y, t->w, y, 0);
        i=pp_wrap(0, y+rand()%200, t->h-1);
        line(t, 0, i, t->w, i, makecol(255,255,255));
      }
      drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
      pp_bwnoise(t, 100);
      t=pp_bmp_interpolate(t);
      t=pp_bmp_interpolate(t);
      break;
    case 3: // snow
      clear_to_color(t, makecol(194,251,254));
      drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
      for (y=0; y<h; y+=rand()%10) { pp_poll_music();
        set_trans_blender(100,100,100,rand()%50);
        line(t, 0, y, t->w, y, 0);
        i=pp_wrap(0, y+rand()%200, t->h-1);
        line(t, 0, i, t->w, i, makecol(255,255,255));
      }
      drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
      pp_bwnoise(t, 100);
      t=pp_bmp_interpolate(t);
      t=pp_bmp_interpolate(t);
      break;
    case 4: // ice, marble, whatever. looks cool anyway
      clear_to_color(t, makecol(194,251,254));
      drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
      for (y=0; y<h; y+=rand()%30) {
        set_trans_blender(100,100,100,rand()%20);
        line(t, 0, y, t->w, y, 0);
        i=pp_wrap(0, y+rand()%200, t->h-1);
        line(t, 0, i, t->w, i, makecol(255,255,255));
      }
      drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
      pp_bwnoise(t, 100);
      drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
      for (y=0; y<h; y++) { pp_poll_music();
        set_trans_blender(100,100,100,rand()%20);
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, 0);
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, makecol(255,255,255));
      }
      drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
      t=pp_bmp_interpolate(t);
      t=pp_bmp_interpolate(t);
      break;
    case 5: // mars
      clear_to_color(t, makecol(213,15,28));
      drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
      for (y=0; y<h; y+=rand()%30) { pp_poll_music();
        set_trans_blender(100,100,100,rand()%20);
        line(t, 0, y, t->w, y, 0);
        i=pp_wrap(0, y+rand()%200, t->h-1);
        line(t, 0, i, t->w, i, makecol(255,255,255));
      }
      drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
      pp_bwnoise(t, 100);
      drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
      for (y=0; y<h; y++) { pp_poll_music();
        set_trans_blender(100,100,100,rand()%20);
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, 0);
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, makecol(255,255,255));
      }
      drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
      t=pp_bmp_interpolate(t);
      t=pp_bmp_interpolate(t);
      break;
    case 6: // psychedelic
      clear_to_color(t, makecol(175,169,247));
      drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
      for (y=0; y<h; y++) { pp_poll_music();
        set_trans_blender(100,100,100,rand()%120);
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, makecol(247,169,222));
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, makecol(247,182,169));
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, makecol(247,233,169));
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, makecol(169,247,239));
        circlefill(t, rand()%t->w, rand()%t->h, 10+rand()%30, makecol(180,247,169));
      }
      drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
      pp_bwnoise(t, 40);
      t=pp_bmp_interpolate(t);
      t=pp_bmp_interpolate(t);
      break;
    case 7: // mouse icon
      clear_to_color(t, makecol(255,0,255));
      line(t, 0, 0, w-(w/2), h-1, 0);
      line(t, 0, 0, w-1, h-(h/2), 0);
      line(t, w-(w/2), h-1, w/2, h/2, 0);
      line(t, w-1, h-(h/2), w/2, h/2, 0);
      floodfill(t, w/4, h/4, makecol(150,150,150));
      break;
    default:
      break;
  }
  return t;
}

// interpolate and return the interpolated bitmap. supersupersupersupersuperSLOW.
BITMAP *pp_bmp_interpolate(BITMAP *src) {
  BITMAP *t=NULL; int x, y, r, g, b, c;
  if (!src) return NULL;
  t=create_bitmap(src->w, src->h);
  if (t) {
    for(x=0; x<src->w; x++) { pp_poll_music(); for(y=0; y<src->h; y++) { 
      r=0; g=0; b=0;
      c=getpixel(src, pp_wrap(0,x-1,src->w-1), pp_wrap(0,y-1,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x,src->w-1), pp_wrap(0,y-1,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x+1,src->w-1), pp_wrap(0,y-1,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x-1,src->w-1), pp_wrap(0,y,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x,src->w-1), pp_wrap(0,y,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x+1,src->w-1), pp_wrap(0,y,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x-1,src->w-1), pp_wrap(0,y+1,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x,src->w-1), pp_wrap(0,y+1,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      c=getpixel(src, pp_wrap(0,x+1,src->w-1), pp_wrap(0,y+1,src->h-1)); r+=getr(c); g+=getg(c); b+=getb(c);
      r/=9; g/=9; b/=9;
      putpixel(t, x, y, makecol(pp_cap(0,r,255), pp_cap(0,g,255), pp_cap(0,b,255)));
    }}
    destroy_bitmap(src);
    return t;
  }
  return src;
}

// draws that little "waiting/thinking" clock in the lower-right corner.
// always wanted to have one of those
void pp_draw_wait(void) {
  if (pp_globals.think) {
    draw_sprite(screen, pp_globals.think, pp_SCREEN_WIDTH-10-pp_globals.think->w, pp_SCREEN_HEIGHT-10-pp_globals.think->h);
  }
}

// the textout function for the cutscene player
void pp_intro_textout(int mip, int cp, int map, int tc, char *line1, char *line2, char *line3) {
  if (cp<mip || cp>map) return;
  // cp is the current position, mip & map are the limits of this "frame", tc is the tick counter
  // that didn't really make any fawking sense
  if (line1) {
    if (cp==mip) textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-190+(20-tc), makecol((255/20.0)*tc,(255/20.0)*tc,(255/20.0)*tc), "%s", line1);
    else if (cp==map) textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-190-tc, makecol((255/20.0)*(20-tc),(255/20.0)*(20-tc),(255/20.0)*(20-tc)), "%s", line1);
    else textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-190, makecol(255,255,255), "%s", line1);
  }
  if (line2) {
    if (cp==mip) textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-170+(20-tc), makecol((255/20.0)*tc,(255/20.0)*tc,(255/20.0)*tc), "%s", line2);
    else if (cp==map) textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-170-tc, makecol((255/20.0)*(20-tc),(255/20.0)*(20-tc),(255/20.0)*(20-tc)), "%s", line2);
    else textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-170, makecol(255,255,255), "%s", line2);
  }
  if (line3) {
    if (cp==mip) textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-150+(20-tc), makecol((255/20.0)*tc,(255/20.0)*tc,(255/20.0)*tc), "%s", line3);
    else if (cp==map) textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-150-tc, makecol((255/20.0)*(20-tc),(255/20.0)*(20-tc),(255/20.0)*(20-tc)), "%s", line3);
    else textprintf_centre(pp_globals.dblbuf, font, pp_SCREEN_WIDTH/2, pp_SCREEN_HEIGHT-150, makecol(255,255,255), "%s", line3);
  }
}

// the image displayer for the cutscene player
void pp_intro_image(int mip, int cp, int map, int tc, BITMAP *bmp) {
  if (cp<mip || cp>map) return;
  // cp is the current position, mip & map are the limits of this "frame", tc is the tick counter
  // and no, it still doesn't make any sense
  if (bmp) {
    if (cp==mip) {
      set_trans_blender(100, 100, 100, (255/20.0)*tc);
      draw_trans_sprite(pp_globals.dblbuf, bmp, (pp_SCREEN_WIDTH/2)-(bmp->w/2)-(20-tc), (pp_SCREEN_HEIGHT/2)-(bmp->h/2)-50);
    }
    else if (cp==map) {
      set_trans_blender(100, 100, 100, (255/20.0)*(20-tc));
      draw_trans_sprite(pp_globals.dblbuf, bmp, (pp_SCREEN_WIDTH/2)-(bmp->w/2)+tc, (pp_SCREEN_HEIGHT/2)-(bmp->h/2)-50);
    }
    else draw_sprite(pp_globals.dblbuf, bmp, (pp_SCREEN_WIDTH/2)-(bmp->w/2), (pp_SCREEN_HEIGHT/2)-(bmp->h/2)-50);
  }
}

// the intro player
void pp_intro(void) {
  int menux, bailout=0, tickctr=0, phasectr=0; BITMAP *bg=NULL;
  DATAFILE *dat=NULL;
  // kawaii desu ne?
  pp_draw_wait();
  // if we don't have intro.dat, we're so not going to play the intro. it's
  // your loss
  dat=load_datafile("intro.dat"); 
  bg=pp_texgen(0, pp_SCREEN_WIDTH, pp_SCREEN_HEIGHT);
  // some moody music..
  pp_play_music(1);
  if (bg) {
    // screws around with the cutscene player bg texture
    drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
    for (tickctr=0; tickctr<20; tickctr++) {
      set_trans_blender(0, 0, 0, tickctr*5);
      rectfill(bg, 0, (bg->h/2)-150+tickctr, bg->w, (bg->h/2)+220-tickctr,0);
    }
    tickctr=0;
    drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
    rectfill(bg, 0, 20, bg->w, 40,0);
    rectfill(bg, 0, 20, bg->w, 20,makecol(100,100,100));
    rectfill(bg, 0, 40, bg->w, 40,makecol(255,255,255));
  }
  menux=255;
  // camera, lights, action!
  if (dat) while (!bailout) {
    if (bg) while(menux>0) {
      clear(pp_globals.dblbuf);
      if (pp_globals.game_bps60) {
        menux-=3;
        if (menux<0) menux=0;
        pp_globals.game_bps60=0;
      }
      if (pp_globals.game_bps20) {
        pp_up_music();
        pp_poll_music();
        pp_globals.game_bps20=0;
      }
      draw_sprite(pp_globals.dblbuf, bg, 0, 0);
      drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
      set_trans_blender(0,0,0,menux);
      rectfill(pp_globals.dblbuf, 0, 0, pp_SCREEN_WIDTH, pp_SCREEN_HEIGHT, 0);
      drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
      textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)-1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the intro, ARROWS to go back/forward");
      textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)+1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the intro, ARROWS to go back/forward");
      textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), pp_SCREEN_HEIGHT-60, makecol(255,255,255), "Press 'ESC' to skip the intro, ARROWS to go back/forward");
      pp_blit();
    }
    if (bg) draw_sprite(pp_globals.dblbuf, bg, 0, 0);
    else clear(pp_globals.dblbuf);
    rectfill(pp_globals.dblbuf, 0, 23, 
      (pp_SCREEN_WIDTH/(87.0*20.0))*((phasectr*20.0)+tickctr), 
      37, makecol(100,200,100));
    line(pp_globals.dblbuf, 0, 23, 
      (pp_SCREEN_WIDTH/(87.0*20.0))*((phasectr*20.0)+tickctr), 
      23, makecol(200,200,200));
    line(pp_globals.dblbuf, 0, 37, 
      (pp_SCREEN_WIDTH/(87.0*20.0))*((phasectr*20.0)+tickctr), 
      37, makecol(50,100,50));
    if (pp_globals.game_bps20) {
      tickctr++;    
      if (tickctr>=21) { tickctr=0; phasectr++; }
      if (key[KEY_LEFT]) {
        tickctr-=5;
        if (tickctr<0) { tickctr+=21; if (phasectr>0) phasectr--; else tickctr=0; }
        key[KEY_LEFT]=0;
      }
      if (key[KEY_RIGHT]) {
        tickctr+=4;
        if (tickctr>=21) { tickctr-=21; phasectr++; }
        key[KEY_RIGHT]=0;
      }
      pp_up_music();
      pp_poll_music();
      pp_globals.game_bps20=0;      
    }
    // yeah, ok
    pp_intro_image(0, phasectr, 11, tickctr, dat[0].dat);
    pp_intro_textout(0, phasectr, 4, tickctr,
      "Say hi to Bob.", // <- laughed at this line
      NULL,
      NULL);
    pp_intro_textout(5, phasectr, 11, tickctr,
      "Bob likes chemicals.",
      "Bob especially likes them eaten, smoked and injected.",
      "Bob is a little chemist himself too.");
    pp_intro_image(12, phasectr, 30, tickctr, dat[1].dat);
    pp_intro_textout(12, phasectr, 20, tickctr,
      "One day while experimenting, Bob made a mistake though.",
      "He injected the stuff he had previously labelled as \"KTHXNO\",",
      "but a stain covered the \"NO\" partially and Bob thought the vial said \"KTHX!\".");
    pp_intro_textout(21, phasectr, 30, tickctr,
      "Now he's stuck in a seemingly neverending trip, and he's not alone.",
      "In his trip, he ended up on planet Mars, and we all know that",
      "the ferocious natives of Mars don't really like company.");
    pp_intro_image(31, phasectr, 40, tickctr, dat[2].dat);
    pp_intro_textout(31, phasectr, 40, tickctr,
      "Even though they are only in his imagination, they can still cause",
      "severe mental trauma with their eye lasers and such.",
      "Bob really feels that this is not a good place for him."); // <- laughed at this line
    pp_intro_image(41, phasectr, 55, tickctr, dat[3].dat);
    pp_intro_textout(41, phasectr, 55, tickctr,
      "To save Bob, you must help him mix an antidote that will halt the trip - and",
      "fast! If you dawdle too much, the ferocious martians will catch Bob and the",
      "traumas will force him into a catatonic state.");
    pp_intro_image(56, phasectr, 63, tickctr, dat[4].dat);
    pp_intro_textout(56, phasectr, 60, tickctr,
      "Do not just chill out, or Bob ends three feet under.",
      "And we don't want to lose Bob.",
      "Bob is our precioussssssss.");
    pp_intro_textout(61, phasectr, 63, tickctr,
      "...ANYWAY.",
      NULL,
      NULL);
    pp_intro_image(64, phasectr, 76, tickctr, dat[3].dat);
    pp_intro_textout(64, phasectr, 70, tickctr,
      "The trip is very dangerous though - it doesn't want to let go of Bob. Bob's",
      "trip has different stages, and each one of them require their own antidote.",
      NULL);
    pp_intro_textout(71, phasectr, 76, tickctr,
      "When Bob uses the antidote, the trip gets more dangerous and also the",
      "antidote required for that stage will be more complex to build.",
      NULL);
    pp_intro_image(77, phasectr, 87, tickctr, dat[5].dat);
    pp_intro_textout(77, phasectr, 87, tickctr,
      "When Bob uses the final antidote, he will break out of the trip.. that is,",
      "if the martians didn't get him first. And so begins the tale..",
      NULL);      
    if (key[KEY_ESC]) {
      bailout=1;
      key[KEY_ESC]=1;
    }
    textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)-1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the intro, ARROWS to go back/forward");
    textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)+1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the intro, ARROWS to go back/forward");
    textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), pp_SCREEN_HEIGHT-60, makecol(255,255,255), "Press 'ESC' to skip the intro, ARROWS to go back/forward");
    if (phasectr>87) bailout=1;
    pp_blit();
  }
  menux=0;
  if (dat) unload_datafile(dat);
  // fadeout and go away
  while(menux<150) {
    if (pp_globals.game_bps60) {
      menux++;
      pp_globals.game_bps60=0;
      drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
      set_trans_blender(0, 0, 0, menux);
      rectfill(pp_globals.dblbuf, 0, 0, pp_SCREEN_WIDTH, pp_SCREEN_HEIGHT, 0);
      drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
      pp_blit();
      pp_draw_wait();
      pp_down_music();
      pp_poll_music();
    }
  }
  pp_stop_music();
  // people DO NOT want to see that again
  pp_globals.intro_played=1;
}

void pp_ending(void) {
  int menux, bailout=0, tickctr=0, phasectr=0; BITMAP *bg=NULL;
  DATAFILE *dat=NULL;
  pp_draw_wait();
  // this shouldn't be here but it's here anyway
  pp_gamedata.level=26;
  // we're cheap and use the images from the intro
  dat=load_datafile("intro.dat"); 
  bg=pp_texgen(0, pp_SCREEN_WIDTH, pp_SCREEN_HEIGHT);
  pp_play_music(1);
  if (bg) {
    drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
    for (tickctr=0; tickctr<20; tickctr++) {
      set_trans_blender(0, 0, 0, tickctr*5);
      rectfill(bg, 0, (bg->h/2)-150+tickctr, bg->w, (bg->h/2)+220-tickctr,0);
    }
    tickctr=0;
    drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
    rectfill(bg, 0, 20, bg->w, 40,0);
    rectfill(bg, 0, 20, bg->w, 20,makecol(100,100,100));
    rectfill(bg, 0, 40, bg->w, 40,makecol(255,255,255));
  }
  menux=255;
  if (dat) while (!bailout) {
    if (bg) while(menux>0) {
      clear(pp_globals.dblbuf);
      if (pp_globals.game_bps60) {
        menux-=3;
        if (menux<0) menux=0;
        pp_globals.game_bps60=0;
      }
      if (pp_globals.game_bps20) {
        pp_up_music();
        pp_poll_music();
        pp_globals.game_bps20=0;
      }
      draw_sprite(pp_globals.dblbuf, bg, 0, 0);
      drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
      set_trans_blender(0,0,0,menux);
      rectfill(pp_globals.dblbuf, 0, 0, pp_SCREEN_WIDTH, pp_SCREEN_HEIGHT, 0);
      drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
      textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)-1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the ending, ARROWS to go back/forward");
      textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)+1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the ending, ARROWS to go back/forward");
      textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), pp_SCREEN_HEIGHT-60, makecol(255,255,255), "Press 'ESC' to skip the ending, ARROWS to go back/forward");
      pp_blit();
    }
    if (bg) draw_sprite(pp_globals.dblbuf, bg, 0, 0);
    else clear(pp_globals.dblbuf);
    rectfill(pp_globals.dblbuf, 0, 23, 
      (pp_SCREEN_WIDTH/(80.0*20.0))*((phasectr*20.0)+tickctr), 
      37, makecol(100,200,100));
    line(pp_globals.dblbuf, 0, 23, 
      (pp_SCREEN_WIDTH/(80.0*20.0))*((phasectr*20.0)+tickctr), 
      23, makecol(200,200,200));
    line(pp_globals.dblbuf, 0, 37, 
      (pp_SCREEN_WIDTH/(80.0*20.0))*((phasectr*20.0)+tickctr), 
      37, makecol(50,100,50));
    if (pp_globals.game_bps20) {
      tickctr++;    
      if (tickctr>=21) { tickctr=0; phasectr++; }
      if (key[KEY_LEFT]) {
        tickctr-=5;
        if (tickctr<0) { tickctr+=21; if (phasectr>0) phasectr--; else tickctr=0; }
        key[KEY_LEFT]=0;
      }
      if (key[KEY_RIGHT]) {
        tickctr+=4;
        if (tickctr>=21) { tickctr-=21; phasectr++; }
        key[KEY_RIGHT]=0;
      }
      pp_up_music();
      pp_poll_music();
      pp_globals.game_bps20=0;      
    }
    // here we go again
    pp_intro_image(0, phasectr, 11, tickctr, dat[1].dat);
    pp_intro_textout(0, phasectr, 4, tickctr,
      "After Bob took the final antidote, he felt like really bad.",
      "It was like his head was exploding, but the antidote still worked.",
      NULL);
    pp_intro_textout(5, phasectr, 11, tickctr,
      "Slowly, he felt like he was returning to the reality",
      "and soon the martian landscapes started to resemble the lines",
      "of his little shed.");
    pp_intro_image(12, phasectr, 30, tickctr, dat[0].dat);
    pp_intro_textout(12, phasectr, 20, tickctr,
      "After about half an hour, Bob felt completely rejuvenated, and",
      "he called his friend to come by and visit. Bob promised that he",
      "had a really screwed up tale to tell.");
    pp_intro_textout(21, phasectr, 30, tickctr,
      "After five minutes, someone knocked on the shed's door and",
      "Bob went to open it.",
      NULL);
    pp_intro_image(31, phasectr, 50, tickctr, dat[2].dat);
    pp_intro_textout(31, phasectr, 40, tickctr,
      "The look on Bob's face suddenly froze. He was looking at an",
      "martian - eye-to-eye. Bob made a small scream, but it was",
      "already too late for him.");
    pp_intro_textout(41, phasectr, 50, tickctr,
      "Sucks to be a Bob.", // <- laughed at this line. and no, it's not a typo.
      NULL,
      NULL);
    pp_intro_textout(51, phasectr, 60, tickctr,
      "@@ THANK YOU FOR PLAYING @@",
      "Perilous PEREGRINATION",
      "Inphernic's entry to TINS 2003");
    pp_intro_textout(61, phasectr, 70, tickctr,
      "I had fun making this game",
      NULL,
      "I hope you had fun playing it! @");
    pp_intro_textout(71, phasectr, 80, tickctr,
      "See you in TINS 2004! ;)",
      NULL,
      "That is, if the martians do not get you first..");
    if (key[KEY_ESC]) {
      bailout=1;
      key[KEY_ESC]=1;
    }
    textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)-1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the ending, ARROWS to go back/forward");
    textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2)+1, pp_SCREEN_HEIGHT-60, makecol(255,127+(120*sin(pp_globals.fx_angle)),0), "Press 'ESC' to skip the ending, ARROWS to go back/forward");
    textprintf_centre(pp_globals.dblbuf, font, (pp_SCREEN_WIDTH/2), pp_SCREEN_HEIGHT-60, makecol(255,255,255), "Press 'ESC' to skip the ending, ARROWS to go back/forward");
    if (phasectr>80) bailout=1;
    pp_blit();
  }
  menux=0;
  if (dat) unload_datafile(dat);
  // fadeout again
  while(menux<150) {
    if (pp_globals.game_bps60) {
      menux++;
      pp_globals.game_bps60=0;
      drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
      set_trans_blender(0, 0, 0, menux);
      rectfill(pp_globals.dblbuf, 0, 0, pp_SCREEN_WIDTH, pp_SCREEN_HEIGHT, 0);
      drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
      pp_blit();
      pp_draw_wait();
      pp_down_music();
      pp_poll_music();
    }
  }
  pp_stop_music();
}

// clear the level data
void pp_clear_level(void) {
  int x, y;
  for (y=0; y<6; y++) {
    for(x=0; x<12; x++) {
      pp_gamedata.leveldata[y].res[x]=-1;
      pp_gamedata.leveldata[y].elm[x]=-1;
    }
  }
  pp_gamedata.entry=0;
}

// move the history columns one step left
void pp_move_history(void) {
  int x, y;
  for (y=0; y<6; y++) {
    for(x=1; x<12; x++) {
      pp_gamedata.leveldata[y].res[x-1]=pp_gamedata.leveldata[y].res[x];
      pp_gamedata.leveldata[y].elm[x-1]=pp_gamedata.leveldata[y].elm[x];
    }
    pp_gamedata.leveldata[y].res[11]=-1;
    pp_gamedata.leveldata[y].elm[11]=-1;
  }
  pp_gamedata.entry=0;
}

// create the level & jello keys for the current level (range = elements allowed)
void pp_create_keys(int range) {
  int x;
  for (x=0; x<6; x++) {
    pp_gamedata.key_level[x]=1+(rand()%range);
    pp_gamedata.key_jello[x]=pp_gamedata.key_level[x];
    while (pp_gamedata.key_jello[x]==pp_gamedata.key_level[x]) pp_gamedata.key_jello[x]=1+rand()%range;
  }
}

// checks if keys match - ret = 1 if jello key, ret = 2 if level key
int pp_key_match(void) {
  int x, lm=0, jm=0;
  for (x=0; x<pp_gamedata.rows; x++) {
    pp_gamedata.leveldata[x].res[11]=0;
    if (pp_gamedata.leveldata[x].elm[11]==pp_gamedata.key_jello[x]) {
      pp_gamedata.leveldata[x].res[11]=2; jm++;
    }
    else if ((pp_gamedata.leveldata[x].elm[11]-1)==pp_gamedata.key_jello[x]) pp_gamedata.leveldata[x].res[11]=1;
    else if ((pp_gamedata.leveldata[x].elm[11]+1)==pp_gamedata.key_jello[x]) pp_gamedata.leveldata[x].res[11]=1;
    if (pp_gamedata.leveldata[x].elm[11]==pp_gamedata.key_level[x]) {
      pp_gamedata.leveldata[x].res[11]=4; lm++;
    }
    else if ((pp_gamedata.leveldata[x].elm[11]-1)==pp_gamedata.key_level[x]) pp_gamedata.leveldata[x].res[11]=3;
    else if ((pp_gamedata.leveldata[x].elm[11]+1)==pp_gamedata.key_level[x]) pp_gamedata.leveldata[x].res[11]=3;
  }
  if (jm==pp_gamedata.rows) return 1;
  if (lm==pp_gamedata.rows) return 2;
  return 0;
}

// a cheap draw element function 
void pp_draw_element(BITMAP *bmp, int elm, int x, int y) {
  int c; char tx[5];
  circlefill(bmp, x, y, 16, makecol(0,0,0)); 
  switch(elm) {
    // i made the colours up, but the elements are valid
    case 0: c=makecol(45,147,45); strcpy(tx, "Sb"); break;
    case 1: c=makecol(50,45,147); strcpy(tx, "O"); break;
    case 2: c=makecol(147,45,45); strcpy(tx, "Cu"); break;
    case 3: c=makecol(200,200,200); strcpy(tx, "Al"); break;
    case 4: c=makecol(220,150,246); strcpy(tx, "I"); break;
    case 5: c=makecol(150,157,246); strcpy(tx, "Kr"); break;
    case 6: c=makecol(150,246,234); strcpy(tx, "Yb"); break;
    case 7: c=makecol(184,246,150); strcpy(tx, "Uuu"); break;
    case 8: c=makecol(246,231,150); strcpy(tx, "Au"); break;
    case 9: c=makecol(245,160,146); strcpy(tx, "Br"); break;
  }
  circlefill(bmp, x, y, 15, c);
  textprintf_centre(bmp, font, x+1, y-(text_height(font)/2)+1, 0, "%s", tx);
  textprintf_centre(bmp, font, x, y-(text_height(font)/2), makecol(255,255,255), "%s", tx);
}

#endif
