#ifndef PERILOUS_HISCORE_C
#define PERILOUS_HISCORE_C

#include <allegro.h>
#include <string.h>
#include "hiscore.h"

// set defaults for the highscore table
void pp_hiscore_set_defaults(void) {
  int i;
  for (i=0; i<10; i++) {
    pp_hiscore_entries[i].score=((10-i)*20000);
    pp_hiscore_entries[i].level=20-(i*2);
    strncpy(pp_hiscore_entries[i].name, "Inphernic", 9);
  }
}

// read highscores to hiscore.dat
int pp_hiscore_read(void) {
  PACKFILE *f=NULL; int i,s;
  f=pack_fopen("hiscore.dat", "r");
  if (f) {
    for(i=0; i<10; i++) {
      pack_fread(&pp_hiscore_entries[i].score, sizeof(int), f);
      pack_fread(&pp_hiscore_entries[i].level, sizeof(int), f);
      for(s=0; s<pp_HISCORE_MAXLEN; s++) pack_fread(&pp_hiscore_entries[i].name[s], sizeof(char), f);
    }
    pack_fclose(f);
    return 1;
  }
  return 0;
}

// save highscores to hiscore.dat
int pp_hiscore_save(void) {
  PACKFILE *f=NULL; int i,s;
  f=pack_fopen("hiscore.dat", "w");
  if (f) {
    for(i=0; i<10; i++) {
      pack_fwrite(&pp_hiscore_entries[i].score, sizeof(int), f);
      pack_fwrite(&pp_hiscore_entries[i].level, sizeof(int), f);
      for(s=0; s<pp_HISCORE_MAXLEN; s++) pack_fwrite(&pp_hiscore_entries[i].name[s], sizeof(char), f);
    }
    pack_fclose(f);
    return 1;    
  }
  return 0;    
}

// check if the score is eligible for HoF - 0 if not, 1 if yes
int pp_hiscore_new(int score) {
  int x=0, i;
  for (i=0; i<10; i++) {
    if ((unsigned int)score>pp_hiscore_entries[i].score) { x=1; i=10; }
  }
  return x;
}

// adds a highscore, and grabs the name from uchar hien (defined above)
void pp_hiscore_add(int score, int level) {
  int i, x;
  for (i=0; i<10; i++) {
    if ((unsigned int)score>pp_hiscore_entries[i].score) { 
      if (i<9) {
        for (x=8; x>=i; x--) {
          pp_hiscore_entries[x+1].score=pp_hiscore_entries[x].score;
          pp_hiscore_entries[x+1].level=pp_hiscore_entries[x].level;
          strcpy(pp_hiscore_entries[x+1].name, pp_hiscore_entries[x].name);
        }
      }
      pp_hiscore_entries[i].score=score;
      pp_hiscore_entries[i].level=level;
      strcpy(pp_hiscore_entries[i].name, hien);
      i=10;
    }
  }
}

#endif
