#ifndef PERILOUS_HISCORE_H
#define PERILOUS_HISCORE_H

// maximum length of a name in the highscore list
// might be best left untouched unless you're suicidal
#define pp_HISCORE_MAXLEN       10

// the highscore entry object
typedef struct {
  unsigned int score;
  unsigned int level;
  char name[pp_HISCORE_MAXLEN];
} pp_hiscore_entry;

// the Hall of Fame (hiscore board)
pp_hiscore_entry pp_hiscore_entries[10];

// hiscore name entry temporary string
unsigned char hien[pp_HISCORE_MAXLEN];

// set defaults for the highscore table
void pp_hiscore_set_defaults(void);

// read highscores to hiscore.dat
int pp_hiscore_read(void);

// save highscores to hiscore.dat
int pp_hiscore_save(void);

// check if the score is eligible for HoF - 0 if not, 1 if yes
int pp_hiscore_new(int score);

// adds a highscore, and grabs the name from uchar hien (defined above)
void pp_hiscore_add(int score, int level);

#endif
