#ifndef PERILOUS_MUSIC_C
#define PERILOUS_MUSIC_C

#include "music.h"

#ifdef pp_MUSIC

// initialize music stuff
void pp_install_music(void) {
  duhdatafile=NULL;
  dumb_register_packfiles();
  dumb_register_dat_it(DUMB_DAT_IT);
  duhdatafile=load_datafile("music.dat");
  duhplayer=NULL;
  playindex=-1;
  duhvolume=0.0;
}

// remove music stuff
void pp_remove_music(void) {
  if (duhdatafile) {
    pp_stop_music();
    unload_datafile(duhdatafile);
  }
  playindex=-1;
  dumb_exit();
}
#endif

// play a track
void pp_play_music(int i) {
  // doesn't do anything if there's no music support
  #ifdef pp_MUSIC
  if (duhdatafile) {
    if (i>=0 && i<3 && playindex!=i) {
      pp_stop_music();
      duhplayer=al_start_duh(duhdatafile[i].dat, 2, 0, .5, 4096, 22050);
      if (duhplayer) playindex=i;
    }
  }
  #else
  // plz ph33r 
  i=0;
  #endif
}

// poll the playing music track
void pp_poll_music(void) {
  #ifdef pp_MUSIC
  // doesn't do anything if there's no music support
  if ((playindex!=-1) && duhplayer) al_poll_duh(duhplayer);
  #endif
}

// gradually raises the volume of the playing track
void pp_up_music(void) {
  #ifdef pp_MUSIC
  // doesn't do anything if there's no music support
  if ((playindex!=-1) && duhplayer && duhvolume<0.5) {
    duhvolume+=.005;
    if (duhvolume<=0.5) al_duh_set_volume(duhplayer, duhvolume);
    else duhvolume=0.5;
  }
  #endif
}

// gradually lowers the volume of the playing track
void pp_down_music(void) {
  #ifdef pp_MUSIC
  // doesn't do anything if there's no music support
  if ((playindex!=-1) && duhplayer && duhvolume>0.0) {
    duhvolume-=.005;
    if (duhvolume>=0.0) {
      al_duh_set_volume(duhplayer, duhvolume);
    }
    else {
      pp_stop_music();
      duhvolume=0.0;
    }
  }
  #endif
}

// stop music
void pp_stop_music(void) {
  #ifdef pp_MUSIC
  // doesn't do anything if there's no music support
  if (duhplayer) al_stop_duh(duhplayer);
  duhplayer=NULL;
  playindex=-1;
  duhvolume=0.0;
  #endif
}

#endif
